#!/usr/bin/python

import sys 
from string import *
from Numeric import *
import math
sys.path.append("/home/won/WON/")
import Common
import Sequtil
import PWMutil
import Util
import fileinput
from stat import ST_SIZE
import os

def GetLabelInfo(seq,offset,PWM,BackPWM,printout,cutoff=0):
    phylopath ="/home/won/data/goldenpath/hg16/phylo/"
    sequence = seq["seq"]
    label    = seq["pred"]

    if printout: print seq["title"]
    else:	 report = seq["title"]
   
    if offset!="":
	chr_no, c_location = offset.split("_")
	c_begin, c_end = c_location.split("-")
	c_begin = long(c_begin)
	c_end   = long(c_end)
    else:   
	c_begin = c_end = 0
	 
    # trace locations
    for i in range(1,len(label)):
	if (label[i-1]=="x") & (label[i]!='x'):
	    #print label[i-1:i+1]
	    location = i  # 0 base
	    typenumber = ord(label[i])-ord('A')
	    pwmtype   = PWM[typenumber]["title"].split()[0].replace(">","")
	    end_loc = location + len(PWM[typenumber]["matrix"])
	    
	    absol_begin = location +c_begin
	    absol_end   = end_loc + c_begin -1
	    
	    if offset!="":
		avgevol = getEvol(phylopath,chr_no,absol_begin,absol_end)
	    else: avgevol = 1
	    if avgevol>=cutoff: 
		print pwmtype, location, end_loc, absol_end-absol_begin, avgevol, "-"

    return 

def getEvol(phylopath,chr,begin,end):
    avg = 0.0
    length = 0
    filename = phylopath+chr
    size = os.stat(filename)[ST_SIZE]
    fp = open(filename,"r")
    division = 1500 
    #print size
    point = 0
    start_point = 0
    for i in range(division):
	point =	point+ size/division
	fp.seek(point)
	fp.readline()
	loc,p = fp.readline().split()
	if (long(loc)>=begin) :
	    start_loc = long(loc)
	    start_point = point - size/division
	    break
    #print start_point
    
    #for line in fileinput.input(filename):
    fp.seek(start_point)
    fp.readline()
    while True:
	line = fp.readline()
	coordinate, prob = line.split()
	coord = long(coordinate)
	if (begin<=coord) & ( end>=coord):
	    #print begin, coord
	    avg += float(prob)
	    length+=1
	if coord>end: break
    #print avg, length
    if length==0:
	return 0.000001
    return float(avg)/float(length)

def GetExpLoc(pwmfile, pseudonum, normalize):
    #print str(len(S))+" sequences are being processed"
    PWM = PWMutil.GetPWM(pwmfile,pseudo=pseudonum, norm=normalize)

    ###########################################
    #  Read PWM and read infofile (expression file) according to it

    titlelist = []  #PWM title
    dict_array=[]
    for i in range(len(PWM)):
	exp_dict = {}
	title = PWM[i]["title"].split()[0].replace(">","")
	if title=="": title = PWM[i]["title"].split()[1]
	titlelist.append(title)
	#print title
	infofile = title+"_new.info"
	try:
	    f_handle = open(infofile,"r")
	except IOError:
	    print "file "+infofile+" is not found"
	    sys.exit(1)
	#########################################
	# Construct Expression Dictionary
	for line in f_handle.readlines():
	    elem = line.split()
	    if (len(elem)<6): continue
	    if (elem[4]=='R') | (elem[4]=='F'):
		# name : prob, seq, location, direction, expr
		locationlist = elem[6:]
		loclist = []
		for loc_i in range(len(locationlist)):
		    ratio,loc,strand = locationlist[loc_i][1:len(locationlist[loc_i])-1].split(",")
		    loclist.append((ratio,loc,strand))
		   
		if len(loclist)==0: # no infor about loc
		    pass
		#    print elem, infofile
		#    sys.exit(1) 
		elem[0] = elem[0].replace(":","_")
		exp_dict[elem[0]] = elem[1],elem[2],elem[3],elem[4],elem[5],loclist
		    
	dict_array.append(exp_dict)
	f_handle.close()
    return titlelist, dict_array

def GetExp(pwmfile, pseudonum, normalize):
    #print str(len(S))+" sequences are being processed"
    PWM = PWMutil.GetPWM(pwmfile,pseudo=pseudonum, norm=normalize)

    ###########################################
    #  Read PWM and read infofile (expression file) according to it

    titlelist = []
    dict_array=[]
    for i in range(len(PWM)):
	exp_dict = {}
	title = PWM[i]["title"].split()[0].replace(">","")
	if title=="": title = PWM[i]["title"].split()[1]
	titlelist.append(title)
	#print title
	infofile = title+".info"
	try:
	    f_handle = open(infofile,"r")
	except IOError:
	    print "file "+infofile+" is not found"
	    sys.exit(1)
	#########################################
	# Construct Expression Dictionary
	for line in f_handle.readlines():
	    elem = line.split()
	    if (len(elem)!=6): continue
	    if (elem[4]=='R') | (elem[4]=='F'):
		# name : prob, seq, location, direction, expr
		exp_dict[elem[0]] = elem[1],elem[2],elem[3],elem[4],elem[5]
	dict_array.append(exp_dict)
	f_handle.close()
    return titlelist, dict_array

def GetChipExp(pwmfile, pseudonum, normalize):
    #print str(len(S))+" sequences are being processed"
    PWM = PWMutil.GetPWM(pwmfile,pseudo=pseudonum, norm=normalize)

    ###########################################
    #  Read PWM and read infofile (expression file) according to it

    titlelist = []
    dict_array=[]
    for i in range(len(PWM)):
	exp_dict = {}
	title = PWM[i]["title"].split()[0].replace(">","")
	if title=="": title = PWM[i]["title"].split()[1]
	titlelist.append(title)
	#print title
	directory = "./"
	#infofile = directory+title+".rst3"
	infofile = directory+title+".rst3"
	try:
	    f_handle = open(infofile,"r")
	except IOError:
	    print "file "+infofile+" is not found"
	    sys.exit(1)
	#########################################
	# Construct Expression Dictionary
	for line in f_handle.readlines():
	    elem = line.split()
	    if elem[0][0:2]=="EN":
		if elem[1][0:3] == "chr":
		    exp_dict[elem[0]] = elem[1],elem[2],elem[3]
	dict_array.append(exp_dict)
	f_handle.close()
    return titlelist, dict_array

def GetChipExp2(pwmfile, pseudonum, normalize):
    PWM = PWMutil.GetPWM(pwmfile,pseudo=pseudonum, norm=normalize)


    titlelist = []
    dict_array=[]
    for i in range(len(PWM)):
	exp_dict = {}
	title = PWM[i]["title"].split()[0].replace(">","")
	if title=="": title = PWM[i]["title"].split()[1]
	titlelist.append(title)
	#print title
	directory = "./"
	#infofile = directory+title+".rst3"
	infofile = directory+title+".bed17Clu"
	try:
	    f_handle = open(infofile,"r")
	except IOError:
	    print "file "+infofile+" is not found"
	    sys.exit(1)
	#########################################
	# Construct Expression Dictionary
	for line in f_handle.readlines():
	    elem = line.split()
	    exp_dict[elem[3]] = elem[0]+"_"+elem[1]+"-"+elem[2], elem[4],elem[4]
	    #if elem[0][0:2]=="EN":
		#if elem[1][0:3] == "chr":
		#    exp_dict[elem[0]] = elem[1],elem[2],elem[3]
	dict_array.append(exp_dict)
	f_handle.close()
    return titlelist, dict_array


#####################################3
#find only left and right end
def GetResultList(pred,ref):
    tmpdict={}
    for i in range(len(ref)):
	alphabet = ref[i:i+1]
	begin = pred.find(alphabet)
	end   = pred.rfind(alphabet)
	tmpdict[alphabet]=[begin,end]
    return tmpdict

def GetResultAllList(pred,ref):
    tmpdict={}
#    for i in range(len(ref)):
#	alphabet = ref[i:i+1]
#	mlist=[]
#	for j in range(len(pred)):
#	    if pred[j:j+1]==alphabet:
#		if (j==0) | (pred[j-1:j]=='x'):
#		    mlist.append(j)
#	tmpdict[alphabet]=mlist
    mlist=[]
    for j in range(len(pred)):
	if pred[j:j+1]!='x':
	    mdict={}
	    if (j==0) | (pred[j-1:j]=='x'):
		mdict[j]=pred[j:j+1]
		mlist.append(mdict)
    return mlist

def GetHisRecord(file):
    Record = []
    fp = open(file,"r")
    for line in fp.readlines():
	tmp = line.split()
	Record.append(tmp)
    fp.close()
    return Record
	 
def FilterDistance(target,distance):
	count=0
	alist = []
	#print target	
	tlist = target.split('x')
	targetlist = []
	for i in range(len(tlist)):
		if len(tlist[i])>0:
			targetlist.append(tlist[i])
	#print targetlist
	t_fr = -1
	for i in range(len(targetlist)):
		t_fr = target.find(targetlist[i],t_fr+1)
		alist.append((t_fr,t_fr+len(targetlist[i])))
	#print alist
	
	starget = list(target)
	for i in range(len(alist)):
		if i==0: d1=1000000
		else: d1 = alist[i][0]-alist[i-1][1]
		if i==len(alist)-1: d2 = 100000
		else:	d2 = -alist[i][1]+alist[i+1][0]
		#print d1, d2
		if (d1>distance) & (d2>distance):
			for j in range(alist[i][0],alist[i][1]):
				starget[j:j+1] = 'x'
	target = Util.List2Str(starget)
	#print target
		
	#Util.getch()
		
	return target

