#!/usr/bin/python

import sys 
from string import *
import math
sys.path.append("/home/won/WON/")
import Common
import Sequtil
import PWMutil
import Util
import ChipUtil

####################################
#read sequence file from argv[1]
S = Sequtil.GetSeq(sys.argv[1])
print str(len(S))+" sequences are being processed"

###########################################
#  Read PWM and read infofile (expression file) according to it
TrueThres = 0.001
FalseThres =0.1
#titlelist, dict_array = ChipUtil.GetExp("anchor.pwm",pseudonum=0, normalize = 1)
titlelist, dict_array = ChipUtil.GetChipExp("anchor2.pwm",pseudonum=0, normalize = 1)

countpwm = len(titlelist)
countlist = [0]*countpwm
#############################################
# check the prediction 
TotalT = 0
TotalF = 0
TP  = 0
TN  = 0
FP  = 0
FN  = 0
Truelist = [0]*countpwm
Trueorg = [0]*countpwm
Falseorg = [0]*countpwm
FP_each = [0]*countpwm
TN_each = [0]*countpwm
FN_each = [0]*countpwm
for i in range(len(S)):
    s = S[i]
    pred = s["pred"].split("x")
    seq_title = s["title"].replace(">","")
    #print pred
    
    pred_dict ={}  # to check which label are predicted
    for j in range(len(pred)):
	while len(pred[j])>0:
	    pwmnum = ord(pred[j][0])-ord('A')
	    if pred_dict.has_key(pwmnum): pred_dict[pwmnum] = pred_dict[pwmnum]+1
	    else: pred_dict[pwmnum] = 1
	    countlist[pwmnum]+=1
	    
	    pred[j] = pred[j].replace(pred[j][0],"")
	    #Util.getch()
    ############################# 
    # Get Expression data
    for j in range(countpwm):
	#print dict_array[j]
	if dict_array[j].has_key(seq_title): 
	    pInt = float(dict_array[j][seq_title][2])
	else:
	    print "no data", j, seq_title
	
	
	#else:
	#    dict_array
	#    print seq_title
	
	if pInt < TrueThres:	
	    TotalT += 1
	    Trueorg[j] += 1
	if pInt >= FalseThres:	
	    TotalF += 1
	    Falseorg[j] += 1
	
	if   (pred_dict.has_key(j)) & (pInt<TrueThres): 
	    TP +=1
	    Truelist[j] += 1
	elif (pred_dict.has_key(j)) & (pInt>=FalseThres): 
	    FP +=1
	    FP_each[j] += 1
	elif (pred_dict.has_key(j)==0) & (pInt<TrueThres): 
	    FN +=1
	    FN_each[j] += 1
	elif (pred_dict.has_key(j)==0) & (pInt>=FalseThres): 
	    TN +=1
	    TN_each[j]+=1
	

print "Number of predictions"    

cc = ((TP*TN)-(FP*FN))/math.sqrt( (TP+FN)*(TN+FP)*(TP+FP)*(TN+FN)   )
print "\tTotalT:",TotalT, "TotalF:",TotalF
print "\tTP:",TP, "TN:",TN, "FP:",FP, "FN:",FN
print "CC:",cc
print "Sens:",float(TP)/float(TP+FN), "Spec:",float(TN)/float(TN+FP)

for i in range(countpwm):
    TP = Truelist[i]
    TN = TN_each[i]
    FP = FP_each[i]
    FN = FN_each[i]
    if (TP+FN)*(TN+FP)*(TP+FP)*(TN+FN) ==0:
	cc = 0
    else:    
	cc = ((TP*TN)-(FP*FN))/math.sqrt( (TP+FN)*(TN+FP)*(TP+FP)*(TN+FN)   )
    print titlelist[i]+"\tT,F:",Trueorg[i],Falseorg[i],"\tTP:", Truelist[i],"   FP:",FP_each[i], "   TN:",TN_each[i],"   FN:",FN_each[i], "\tCC:",cc
print " "


 



"""
print s["title"]
print s["seq"]
print s["label"]
print s["pred"]
seqname, seqarray, labelarray, predarray = Common.GetSeq(argv[1])

print seqname[0]
print seqarray[0]
print labelarray[0]
print obsarray[0]
"""


