#!/usr/bin/python

import sys 
from string import *
import math
sys.path.append("/home/won/WON/")
import Common
import Sequtil
import PWMutil
import Util
import ChipUtil

HisDistance = int(sys.argv[2])

####################################
#read sequence file from argv[1]
S = Sequtil.GetSeq(sys.argv[1])
print str(len(S))+" sequences are being processed"

###########################################
#  Read PWM and read infofile (expression file) according to it
TrueThres = 0.001
FalseThres =0.1
#titlelist, dict_array = ChipUtil.GetExp("anchor.pwm",pseudonum=0, normalize = 1)
""" titlelist = [creb, e2f1, max,yy1]
    dict_array = {chr_begin-end: x_val, p_val} """
titlelist, dict_array = ChipUtil.GetChipExp("anchor2.pwm",pseudonum=0, normalize = 1)

#histonefile = "/home/won/project/Histone/untreated.his16"
histonefile = "/home/won/project/Histone/highconf.his16"
histonefile = "histone.dat" # README

hislist = ChipUtil.GetHisRecord(histonefile)
#Util.printlist(hislist)

countpwm = len(titlelist)
countlist = [0]*countpwm
#############################################
# check the prediction 
TotalT = 0
TotalF = 0
TP  = 0
TN  = 0
FP  = 0
FN  = 0
T_promoter =0
T_enhancer = 0
Truelist = [0]*countpwm
Trueorg = [0]*countpwm
Falseorg = [0]*countpwm
FP_each = [0]*countpwm
TN_each = [0]*countpwm
FN_each = [0]*countpwm
for i in range(len(S)):
    s = S[i]
    #pred = s["pred"].split("x")
    seq_title = s["title"].replace(">","")
    #print pred
    chr_no, loc = dict_array[0][seq_title][0].split("_")
    begin, end  = loc.split("-")
    begin = long(begin)
    end = long(end)
    
    pred_dict ={}  # to check which label are predicted
    PosDict=ChipUtil.GetResultList(s["pred"],"ABCD") # A:[10,20],b[-1,-1]
     # dict for A, B, C, D position predicted  A{ [begin,end],[begin,end]}
   
    ################################
    # Histone information
    for j in range(countpwm):
	hisflag=0
	alphabet = chr(ord('A')+j)
	if PosDict[alphabet][0]<0:  pass
	else:	
	    PosDict[alphabet] = PosDict[alphabet][0]+begin, PosDict[alphabet][1]+begin
	    min_dist = 10000000;
	    minlabel = ""
	    for k in range(len(hislist)):
		dista = math.fabs(PosDict[alphabet][0]-float(hislist[k][1]))
		distb = math.fabs(PosDict[alphabet][0]-float(hislist[k][1]))
		dist = min(dista,distb)
		if (chr_no==hislist[k][0]) & (dist<min_dist):
		    min_dist = dist
		    minlabel = hislist[k][3]
		
		if (chr_no==hislist[k][0]) & (dist<HisDistance): # active
		    hisflag=1
		    #(dist<min_dist):
		    #break
	    if hisflag==0:
		PosDict[alphabet] = [-1, -1]
	    
	

    
    ############################# 
    # Get Expression data
    for j in range(countpwm):
	#print dict_array[j]
	if dict_array[j].has_key(seq_title): 
	    pInt = float(dict_array[j][seq_title][2]) # p_val
	else:
	    print "no data", j, seq_title
	
	if pInt < TrueThres:	
	    TotalT += 1
	    Trueorg[j] += 1
	if pInt >= FalseThres:	
	    TotalF += 1
	    Falseorg[j] += 1
	
	alphabet = chr(ord('A')+j)
	
	if   (PosDict[alphabet][0]>=0) & (pInt<TrueThres): 
	    TP +=1
	    Truelist[j] += 1
	    if minlabel=="E": T_enhancer +=1
	    elif minlabel=="P": T_promoter +=1
	elif (PosDict[alphabet][0]>=0) & (pInt>=FalseThres): 
	    FP +=1
	    FP_each[j] += 1
	elif (PosDict[alphabet][0]<0) & (pInt<TrueThres): 
	    FN +=1
	    FN_each[j] += 1
	elif (PosDict[alphabet][0]<0) & (pInt>=FalseThres): 
	    TN +=1
	    TN_each[j]+=1
	

print "Number of predictions"    

cc = ((TP*TN)-(FP*FN))/math.sqrt( (TP+FN)*(TN+FP)*(TP+FP)*(TN+FN)   )
print "\tTotalT:",TotalT, "TotalF:",TotalF
print "\tTP:",TP, "TN:",TN, "FP:",FP, "FN:",FN
print "CC:",cc
print "Sens:",float(TP)/float(TP+FN), "Spec:",float(TN)/float(TN+FP)

for i in range(countpwm):
    TP = Truelist[i]
    TN = TN_each[i]
    FP = FP_each[i]
    FN = FN_each[i]
    if (TP+FN)*(TN+FP)*(TP+FP)*(TN+FN) ==0:
	cc = 0
    else:    
	cc = ((TP*TN)-(FP*FN))/math.sqrt( (TP+FN)*(TN+FP)*(TP+FP)*(TN+FN)   )
    print titlelist[i]+"\tT,F:",Trueorg[i],Falseorg[i],"\tTP:", Truelist[i],"   FP:",FP_each[i], "   TN:",TN_each[i],"   FN:",FN_each[i], "\tCC:",cc
print " "

print "promoter",T_promoter, "enhancer", T_enhancer
 



"""
print s["title"]
print s["seq"]
print s["label"]
print s["pred"]
seqname, seqarray, labelarray, predarray = Common.GetSeq(argv[1])

print seqname[0]
print seqarray[0]
print labelarray[0]
print obsarray[0]
"""


