#!/usr/bin/python
import sys
import os
import string
from Numeric import *
from math import *

class Seq:
    def __init__(self,filename):
	self.modfile = open(filename)
	self.mod = self.modfile.read()
	self.p_fr = -1 
	self.p_to = 0
    def __iter__(self):
	return self
    def next(self):
	self.p_fr = self.mod.find(">",self.p_fr+1)
	self.p_to = self.mod.find(">",self.p_fr+1)
	if self.p_fr < 0: 
	    self.modfile.close()
	    raise StopIteration
	
	if self.p_to>0:
	    return self.mod[self.p_fr:self.p_to-1]
	else:
	    return self.mod[self.p_fr:]
	

def GetSeq(modfile):
    p_fr = p_to = 0
    hInst = Seq(modfile)
    seq = [] 
    for handle in hInst:
	residue=""
	label = ""
	pred = ""
	d_seq = {}
	
	line = handle.split("\n")
	
	title = line[0]
	plp_on = 0
	flag = 0
	plp = []
	for i in range(1,len(line)):
	    if line[i].find("%")>=0: pass
	    elif line[i].replace(" ","")=="": 
			flag=0
			pass
	    elif line[i].find("#")>=0: 
			if flag==1:
				label+=line[i][1:]
			else: plp_on = 1
		
	    elif line[i].find("?")>=0: 
			pred+=line[i][2:]
			flag=0
	    else : 
			if plp_on==0:
				residue += line[i]
				flag = 1
			else: 
				U = line[i].split()[1:]
				plp.append(U)
				
	residue = residue.replace(" ","")
	label   = label.replace(" ","")
	pred    = pred.replace(" ","")

	d_seq["title"] = title
	d_seq["label"] = label
	d_seq["seq"]   = residue
	d_seq["pred"] = pred
	d_seq["plp"] = plp

	if len(label)>0:
	    try:
		assert len(residue) == len(label)
	    except AssertionError:
		print d_seq["title"]
		print "Sequence Error", len(residue), len(label)
		sys.exit(1)

	seq.append(d_seq)
    return seq

def CrossVal(seqfile,cross_num,direc,refname = ""):
    Seq = GetSeq(seqfile)
    fptrain = []
    fptest = []
    fptrainname = []
    fptestname = []
    print direc
    if direc[-1]!="/": direc = direc+"/"
    direc += refname
    for i in range(cross_num):
	fpnt = open(direc+str(i)+".train","w")
	fptrain.append(fpnt)
	fptrainname.append(direc+str(i)+".train")
	fpnt2 = open(direc+str(i)+".test","w")
	fptest.append(fpnt2)
	fptestname.append(direc+str(i)+".test")

    for i in range(len(Seq)):
	alloc = i%cross_num
	seq = Seq[i]["title"]+"\n"+Seq[i]["seq"]+"\n"
	if Seq[i].has_key("label"):
	    seq += Seq[i]["label"]+"\n"
	fptest[alloc].write(seq)
	for j in range(cross_num):
	    if alloc!=j: 
		fptrain[j].write(seq)
		
    for i in range(cross_num):	fptrain[i].close()
    for i in range(cross_num):	fptest[i].close()
    
    return fptrainname, fptestname

def GetMiniTitle(seq):
    title = seq["title"].split()[0].replace(">","")
    if title == "": title = seq["title"].split()[1]
    return title

def CompressTable(orgtable):
    table = {}
    for key1, item1 in orgtable.items():
	flag = 0
	sum = 0
	sum_count = 0
	for key2, item2 in orgtable.items():
	    t1 = int(key1[0])%10
	    t2 = int(key2[0])%10
	    if (t1==t2) & (key1[1]==key2[1]) &(key1[2]!=key2[2]):
		if abs(int(key1[2])-int(key2[2]))<6:
		    flag=1
		    sum+=int(key1[2])+int(key2[2])
		    sum_count +=2
	if flag==0:
	    table[key1]=item1
	else:
	    table[str(t1),key1[1],str(int(sum/sum_count))] = item1
	    #print str(t1),key1[1],str(int(sum/sum_count))
    #print "Table length (no dup):",len(table)
	
    return table


def CompressTable4pwmname(orgtable):
    table = {}
    for key1, item1 in orgtable.items():
	flag = 0
	sum = 0
	sum_count = 0
	for key2, item2 in orgtable.items():
	    t1 = key1[0]
	    t2 = key2[0]
	    if (t1==t2) & (key1[1]==key2[1]) &(key1[2]!=key2[2]):
		if abs(int(key1[2])-int(key2[2]))<6:
		    flag=1
		    sum+=int(key1[2])+int(key2[2])
		    sum_count +=2
	if flag==0:
	    table[key1]=item1
	else:
	    table[t1,key1[1],str(int(sum/sum_count))] = item1
	    #print str(t1),key1[1],str(int(sum/sum_count))
    #print "Table length (no dup):",len(table)
	
    return table

def StatTable(Seq,orgtable,seqlist,minlength=1):
    TP = {}
    
    count = 0

    table = CompressTable(orgtable)
    """
    for key1, item1 in orgtable.items():
	flag = 0
	sum = 0
	sum_count = 0
	for key2, item2 in orgtable.items():
	    t1 = int(key1[0])%10
	    t2 = int(key2[0])%10
	    if (t1==t2) & (key1[1]==key2[1]) &(key1[2]!=key2[2]):
		if abs(int(key1[2])-int(key2[2]))<6:
		    flag=1
		    sum+=int(key1[2])+int(key2[2])
		    sum_count +=2
	if flag==0:
	    table[key1]=item1
	else:
	    table[str(t1),key1[1],str(int(sum/sum_count))] = item1
	    #print str(t1),key1[1],str(int(sum/sum_count))
    print "Table length (no dup):",len(table)
    """
    		    
    for s in range(len(Seq)):
	seq = Seq[s]
	title = GetMiniTitle(seq)

	chunk = ""
	start = 0
	
	for i in range(len(seq["pred"])):
	    if seq["pred"][i:i+1]!='x':
		chunk += seq["pred"][i:i+1]
	    if (i==len(seq["pred"][i:i+1]) ) | (seq["pred"][i:i+1]=='x'):
		if len(chunk)>=minlength:
		    end = i
		    begin = i-len(chunk)
		    
		    prev = ("0","","-100")
		    for key,item in table.items():
			n_pwm= int(key[0])%10
			n_label = ord(chunk[0:1])-ord('A')+1
			pos = int(key[2])

			#print key
			#print seqlist[title], n_pwm, n_label, pos, begin, end
			#if(int(prev[0])%10==n_pwm)&(prev[1]==key[1])& (  abs( int(prev[2])-int(key[2]) )<=10  ): pass
			#if(int(prev[0])%10==n_pwm)&(prev[1]==key[1]): pass
			if (int(key[1])==seqlist[title]) & (n_pwm==n_label) & (pos>begin-6) & (pos<end-3):
			    if n_pwm==1: p="MYF"
			    elif n_pwm==2: p="MEF"
			    elif n_pwm==3: p="TEF"
			    elif n_pwm==4: p="SRF"
			    elif n_pwm==5: p="SP1"
			    else: p='XXX'
			    TP[p,title,key[2]] = item
			    #print p,title,key[2] 
			prev = key 

		    chunk = ""
    return TP

def CompareTable(Match, Report):
    TP = {}
    dup = 0
    old_mat = ("","","")
    for rep,repitem in Report.items():
	for mat,matitem in Match.items():
	     
	    if (rep[0]==mat[0]) & (rep[1]==mat[1]):
		diff =  abs(int(rep[2])-int(mat[2]))
		if diff<7:
		    if TP.has_key(rep):
			dup+=1
			#print "dup:",rep
		    else:
			TP[rep[0],rep[1],rep[2]] = repitem
	    old_mat = mat

    count=0
    for mat1,matitem in Match.items():
	for mat2, mat2item in Match.items():
	    if (mat1[0]==mat2[0]) & (mat1[1]==mat2[1]) & (mat1[2]!=mat2[2]):
		if abs(int(mat1[2])-int(mat2[2]))<=4:  #regarded as same one
		    count+=1
    count = count/2
    return TP,dup

def DistanceTable(True_Table,dist):
   
    dellist = []
     
    count = 0
    for key1, item1 in True_Table.items():
	flag = 0
	for key2,item2 in True_Table.items():
	    if  (key1[1]==key2[1]) & (key1[2]!=key2[2]):
		count+=1
		if abs(int(key1[2])-int(key2[2])) < dist:
		    flag = 1
	if flag==0: dellist.append(key1)
    
    print len(dellist), count
    for i in range(len(dellist)):
	#print dellist[i]
	del True_Table[dellist[i]]
    return True_Table
	
def StatPredChunk(seq,prn=1,minlength=1):
    num_pred = 0
    num_obs  = 0

    obs = seq["label"].split("x")
    for i in range(len(obs)):
	if obs[i]!="":
	    chunk = obs[i]
	    
	    while chunk!="":
		num_obs += 1
		chunk = chunk.replace(chunk[0:1],"")
    pred = seq["pred"].split("x")
    for i in range(len(pred)):
	if pred[i]!="":
	    chunk = pred[i]
	    
	    while chunk!="":
		#if len(chunk) > minlength: num_pred += 1
		if chunk.count(chunk[0:1]) > minlength: num_pred += 1
		chunk = chunk.replace(chunk[0:1],"")
   
    count = 0
    chunk = "" 
    for i in range(len(seq["pred"])):
	if (seq["pred"][i:i+1] == seq["label"][i:i+1]) & (seq["pred"][i:i+1]!='x') & (seq["label"][i:i+1]!='x'):
	    chunk += seq["pred"][i:i+1]
	elif len(chunk)>=minlength:
		if prn==1: print chunk
		chunk = ""
		count += 1
	# at the end of the seq
	if (i==len(seq["pred"])-1) & (len(chunk)>=minlength):
	    if prn==1: print chunk
	    count += 1

    return num_obs, num_pred,count


