#!/usr/bin/python

from sys import *
from string import *
from Numeric import *
path.append("/home/won/WON/")
import Common
import Sequtil
import PWMutil
import ChipUtil
import Util

pwmname = "anchor2.pwm"
cut_off_val = 0.6

S = Sequtil.GetSeq(argv[1])
print str(len(S))+" sequences are being processed"
titlelist, dict_array = ChipUtil.GetExpLoc(pwmname,pseudonum=0, normalize = 1)  #gittar + loc
Chiptitlelist, Chip_dict_array = ChipUtil.GetChipExp(pwmname,pseudonum=0, normalize = 1)

PWM = PWMutil.GetPWM(pwmname,pseudo=0, norm=1)

weight = float(argv[3])
otherintensity = 0.00 
############ deal with file name
if argv[2][-4:] == ".gff":    gff_name = argv[2]
else: gff_name = argv[2]+".gff"
ann_name = gff_name[:-4]+".ann"

print "produce :", gff_name, ann_name
gff = open(gff_name,"w")
ann = open(ann_name,"w")

size = len(titlelist) 

annresult="annotation2labels "
annbg = "bg"
bgother = ""
for i in range(size):
    bgother+=":"+chr(65+i)+"="+str(otherintensity)
annresult += "\t"+annbg+":x="+str(1.0*weight)+bgother+"\\\n"
for s in range(len(S)):
    Seq = S[s]
    title = Seq["title"].replace(">","").upper()
    ####### Get Prob.
    problist = []
    densitylist = []
    imsilist = []
    for i in range(size):  # loop for pwm
	mydict = dict_array[i]
	Chipdict = Chip_dict_array[i]
	density = 0
	
	if mydict.has_key(title):
	    prob,seq,loc, strand, expr, locinfo = mydict[title]
	    Chip_loc, x_val, p_val  = Chipdict[title]
	    #print mydict[title]
	    #print Chipdict[title]
	    #Util.getch()
	    
	    prob = float(prob)
	    if len(locinfo)==0: prob = 0
	    #print  locinfo 
	    #exit(1)
	else:
	    #print title, 0
	    prob = 0
	    seq = ""
	    loc = -1
	    strand = "F"
	    locinfo = []
	if float(p_val)<0.001: density = 1
	elif float(p_val)>0.1: density = 0.0
	else: density  = 0.5

	flag = 0
	git_flank = 7 # Li  gave 7 to it....
	for j in range(len(locinfo)):
	    loc_ratio, loc_pos, loc_strand = locinfo[j]
	    #print loc_ratio, loc_pos, loc_strand, title, i
	    #if float(loc_ratio) < 0:	
	    #	continue
	    loc_pos = int(loc_pos)+1 # to compensate the seq start.  GFF starts from 1, gitta starts from 0
	    if loc_strand =="F":
		loc_begin = int(loc_pos) - git_flank 
		loc_end   = loc_begin+len(PWM[i]["matrix"])-1
	    else:
		loc_end  = len(Seq["seq"])-(int(loc_pos)-git_flank)+1
		loc_begin = loc_end-len(PWM[i]["matrix"])+1
		#if loc_begin < 0:	
		#    print "::",title,loc_begin, loc_end,loc_pos, len(Seq["seq"]),PWM[i]["title"]
		#    Util.getch()
	    #print loc_ratio, loc_begin, loc_end, loc_strand, PWM[i]["title"],len(PWM[i]["matrix"])
	    imsi = (prob, loc_begin, loc_end, titlelist[i], loc_ratio, loc_strand)
	    flag = 1
	    imsilist.append(imsi)
	    #print imsi, title
	#if flag==0: prob = 0
	#exit(1)

		
	"""
	cont_a = PWMutil.SlidePWM(seq=Seq["seq"],pwm = PWM[i]["matrix"], cutoff=0.7 ,prn=0, bothstrand=1)
	cont = cont_a.split("\n")
	for l in range(len(cont)):
	    if len(cont[l].split()) ==4:
		flag =1
		score, pos, seq, strand = cont[l].split()
		imsi = ( prob, int(pos), int(pos)+len(PWM[i]["matrix"]),titlelist[i],score,strand)
		#print imsi
		if imsi[0]>0:
		    imsilist.append(imsi)
	"""
	
	densitylist.append(density)
	problist.append(prob)

    imsilist = Util.sort_by(imsilist,1,reverse=0)
    #print len(imsilist)
    #exit(1)

    gfflist = []
    idx = 0
    intenlist = []
    for i in range(1,len(imsilist)):
	intenlist.append(imsilist[i-1][0])
	alist = [0]*3
	if imsilist[i][1]>imsilist[i-1][2]:
	    #print imsilist[idx][1], imsilist[i-1][2] #firtstart and last end
	    alist[2] = imsilist[i-1][2]
	    alist[0] = max(intenlist)
	    alist[1] = imsilist[idx][1]
	    gfflist.append(alist)
	    intenlist = []
	    idx = i		# next block
	if i==len(imsilist)-1:
	    #print imsilist[idx][1], imsilist[i][2]
	    intenlist.append(imsilist[i][0])
	    alist[2] = imsilist[i][2]
	    alist[0] = max(intenlist)
	    alist[1] = imsilist[idx][1]
	    if imsilist[i][1]<0:	
		print "ddd", imsilist, title
	  #  gfflist.append(alist)
	    try:
		c = gfflist.index(alist)
	    except ValueError:
		gfflist.append(alist) 
	    else: pass

    prev = 1 
    bgstrength = "1"
    ###################################### 
    # write in GFF file
    if sum(densitylist)==0.0:
	gff.write(title+"\tKWON\t"+title+"_bg"+"\t"+"1"+"\t"+str(len(Seq["seq"]))+"\t"+"0.05"+"\t+\t.\t.\n")

    elif len(gfflist)==0:
	gff.write(title+"\tKWON\t"+title+"_bg"+"\t"+"1"+"\t"+str(len(Seq["seq"]))+"\t"+"0.1"+"\t+\t.\t.\n")
   
    else:	
      for i in range(len(gfflist)):
	############################### background
	if gfflist[i][1]> prev:
	    start = str(prev)
	    end   = str(gfflist[i][1]-1)
	    entry = title+"_bg"
	    gff_score = "1"#bgstrength 
	    gff.write(title+"\tKWON\t"+entry+"\t"+start+"\t"+end+"\t"+gff_score+"\t+\t.\t.\n")
	##############################  main
	start = str(gfflist[i][1])
	end   = str(gfflist[i][2])
	entry = title#+"_"+gfflist[i][3]
	#entry = "TF"+"_"+title #gfflist[i][3]
	gff_score = str(gfflist[i][0])
	gff.write(title+"\tKWON\t"+entry+"\t"+start+"\t"+end+"\t"+gff_score+"\t+\t.\t.\n")
	
	prev = int(end)+1
	############################  at the end
	if (i==len(gfflist)-1) & (prev<=len(Seq["seq"])):
	    start = str(prev)
	    end = str(len(Seq["seq"]))
	    entry = title+"_bg"
	    gff_score = bgstrength
	    gff.write(title+"\tKWON\t"+entry+"\t"+start+"\t"+end+"\t"+gff_score+"\t+\t.\t.\n")
   
    #annresult+="\t"+"TF_"+title+"_bg:x=1"
    annresult+="\t"+title+"_bg:x="+str(weight)
    for i in range(size):
	label = chr(65+i)
	if densitylist[i]!=0.0:
	    annresult+=":"+label+"="+str(0.01)#(0.2*weight)
   
    annresult+="\\\n"    
    #annresult+="\t"+"TF_"+title  
    annresult+="\t"+title  
       
    flag = 0
    for i in range(size):
	label = chr(65+i)
	#tensitylist[i] = intensitylist[i]
	str_prob = "%1.4f"%(densitylist[i])
	
	if str_prob!="0.0000":
	    flag = 1
	    #annresult += ":"+label+"="+str(problist[i])
	    annresult += ":"+label+"="+str_prob
	#else:
	 #   annresult += ":"+label+"="+str(otherintensity)
    	    
    
    #background = 1.0	    
    background = 1.0 - max(problist)
    #if max(problist)== w : background = 1
    #if background < 0.5: background = 0.5
    background = 1.*weight #0.5 * weight
    #if sum(problist)<1:  background = 1.0 - max(problist)
    #if background < 0.8:  background = 0.8  # before 57.92  o.6:60.7
    #background = 1.0-max(problist)/3.0 # 61.3
    #background = 1.0-max(problist)/2  # 2:60.6
    annresult +=":x="+str(background)
    
    	    

	
    if s==len(S)-1:	ann.write(annresult+"\n")
    else:		ann.write(annresult+"\\\n")
    annresult = ""
    
gff.close()
ann.close()

	

